/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.eni.technoCeption.vue;

//bibliothèque importé
import java.awt.Color;
import java.awt.Component;
import java.awt.Desktop;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.sql.Array;
import java.util.Date;
import java.sql.SQLException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;

import fr.eni.technoCeption.controleur.C_AS_AutoSearch;
import fr.eni.technoCeption.db.Db_mysql;
import fr.eni.technoCeption.model.M_Categorie;
import fr.eni.technoCeption.model.M_Url;

/**
 * Vue d'url
 * @author gatardf
 */
public class V_Url extends javax.swing.JFrame {

    //déclaration des attributs
    private String login;
    private int mois;
    private int idMotCle;
    private String maCategorie;
    
    //déclaration du modèle et du controlleur
    private DefaultTableModel dm_tb_url;
    private C_AS_AutoSearch leControl;
    private Db_mysql bdAutoSearch;
    
    //déclaration des collections
    private ArrayList<M_Categorie> lesCategories;
    private ArrayList<M_Url> lesUrl;
    
    /**
     * V_Url
     * Constructeur
     * @param leControl : controlleur
     * @param bdAutoSearch : data base
     */
    public V_Url(C_AS_AutoSearch leControl,Db_mysql bdAutoSearch) {
        //affectation des objets
        this.bdAutoSearch = bdAutoSearch;
        this.leControl = leControl;
        
        //initialisation du constructeur
        initComponents();
    }

    /**
     * afficher
     * permet l'affichage de la vue afficher
     * @param Categorie : chaine de caractère
     * @param login : chaine de caractère
     * @param mois
     * @throws SQLException 
     * @throws java.text.ParseException 
     */
    public void afficher(String Categorie,String login, int mois, int idMotCle) throws SQLException, ParseException{
        //Déclaration des variables
        int noLigne;
        int k;
        int nombreDeCategorie;
        int z;
        int y;
        M_Categorie laCategorie;
        this.idMotCle = idMotCle;
        maCategorie = Categorie;
        
        this.mois=mois;
        k=0;
        
        lesCategories = M_Categorie.records(bdAutoSearch);
        nombreDeCategorie=lesCategories.size();
        this.login = login;
        
        
        switch(Categorie){
            case "Historique":
                bt_sup.setText("supprimer");
                break;
            default:
                bt_sup.setText("Modifier");
                break;
        }
        
        bt_sup.setVisible(true);
        
        afficherTableau(Categorie, this.mois, this.idMotCle);
        
        //pour chaque Categorie
        for (y = 0; y < nombreDeCategorie; y++) {
            //affectation des information de la categorie à l'index y
            laCategorie = lesCategories.get(y);
            
            //déclaration du bouton
            JButton bouton;
            
            //création du bouton
            bouton = new JButton("bt_motCle"+y);
            
            //affectation des informations du bouton position taille libelle et action
            bouton.setBounds(10,20+k, 130, 20);
            bouton.setText(laCategorie.getLibelle());
            bouton.addActionListener((ActionEvent e) -> {
                try {
                    //recharge la vue pour la categorie selectionner
                    leControl.aff_V_Url(bouton.getText(), login, this.mois, this.idMotCle);
                } catch (SQLException | ParseException ex) {
                    Logger.getLogger(V_Url.class.getName()).log(Level.SEVERE, null, ex);
                }
            });
            
            //ajoute le bouton au panel lst_Categories
            lst_Categories.add(bouton);
            //ajoute 25 px à k
            k=k+25; 
        }
        
        
        //affiche la vue
        this.setVisible(true);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jScrollPane2 = new javax.swing.JScrollPane();
        tb_Url = new javax.swing.JTable();
        bt_Aller = new javax.swing.JButton();
        bt_Retour = new javax.swing.JButton();
        lst_Categories = new javax.swing.JPanel();
        bt_sup = new javax.swing.JButton();
        lst_mois = new javax.swing.JComboBox<>();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setLocationByPlatform(true);
        setMaximumSize(new java.awt.Dimension(700, 450));
        setMinimumSize(new java.awt.Dimension(700, 450));
        setResizable(false);

        tb_Url.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Titre", "Url", "idUrl", "Date"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.Integer.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, true, true, true
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane2.setViewportView(tb_Url);
        if (tb_Url.getColumnModel().getColumnCount() > 0) {
            tb_Url.getColumnModel().getColumn(0).setResizable(false);
            tb_Url.getColumnModel().getColumn(1).setMinWidth(0);
            tb_Url.getColumnModel().getColumn(1).setPreferredWidth(0);
            tb_Url.getColumnModel().getColumn(1).setMaxWidth(0);
            tb_Url.getColumnModel().getColumn(2).setMinWidth(0);
            tb_Url.getColumnModel().getColumn(2).setPreferredWidth(0);
            tb_Url.getColumnModel().getColumn(2).setMaxWidth(0);
            tb_Url.getColumnModel().getColumn(3).setMinWidth(150);
            tb_Url.getColumnModel().getColumn(3).setPreferredWidth(150);
            tb_Url.getColumnModel().getColumn(3).setMaxWidth(150);
        }

        bt_Aller.setText("Aller à");
        bt_Aller.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bt_AllerActionPerformed(evt);
            }
        });

        bt_Retour.setText("<");
        bt_Retour.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bt_RetourActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout lst_CategoriesLayout = new javax.swing.GroupLayout(lst_Categories);
        lst_Categories.setLayout(lst_CategoriesLayout);
        lst_CategoriesLayout.setHorizontalGroup(
            lst_CategoriesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 142, Short.MAX_VALUE)
        );
        lst_CategoriesLayout.setVerticalGroup(
            lst_CategoriesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 293, Short.MAX_VALUE)
        );

        bt_sup.setText("Supprimer");
        bt_sup.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bt_supActionPerformed(evt);
            }
        });

        lst_mois.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Mois", "Janvier", "Fevrier", "Mars", "Avril", "Mai", "Juin", "Juillet", "Aout", "Septembre", "Octobre", "Novembre", "Decembre" }));
        lst_mois.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                lst_moisActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(0, 20, Short.MAX_VALUE)
                        .addComponent(lst_Categories, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 520, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(bt_Retour)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(lst_mois, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(bt_sup)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(bt_Aller)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(bt_Retour)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(layout.createSequentialGroup()
                            .addGap(24, 24, 24)
                            .addComponent(lst_mois, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 293, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                            .addContainerGap()
                            .addComponent(lst_Categories, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(bt_Aller)
                    .addComponent(bt_sup))
                .addGap(0, 64, Short.MAX_VALUE))
        );

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void bt_AllerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bt_AllerActionPerformed
        // TODO add your handling code here:
        String url;
        int ligne;
        ligne = tb_Url.getSelectedRow();
        if(ligne == -1){
            JOptionPane.showMessageDialog(this, "Choisis un URL(Uniform Resource Locator)", "Attention", JOptionPane.WARNING_MESSAGE);
        }else{
            url = (String) tb_Url.getValueAt(ligne,1);
            int idUrl = (Integer) tb_Url.getValueAt(ligne,2);
            try {
                System.out.println(login);
                M_Url uneUrl = new M_Url(bdAutoSearch,login, idUrl);
            } catch (SQLException ex) {
                Logger.getLogger(V_Url.class.getName()).log(Level.SEVERE, null, ex);
            }
            try {
                Desktop.getDesktop().browse(new URI(url));
            } catch (URISyntaxException | IOException ex) {
                Logger.getLogger(V_Url.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }//GEN-LAST:event_bt_AllerActionPerformed

    private void bt_RetourActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bt_RetourActionPerformed
        try {
            leControl.aff_V_Consultation();
        } catch (IOException | ParseException | SQLException ex) {
            Logger.getLogger(V_Url.class.getName()).log(Level.SEVERE, null, ex);
        }
        setVisible(false);
    }//GEN-LAST:event_bt_RetourActionPerformed

    private void bt_supActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bt_supActionPerformed
        // TODO add your handling code here:
        int id;
        int ligne;
        ligne = tb_Url.getSelectedRow();
        if(bt_sup.getText()=="Modifier"){
            if(ligne == -1){
                JOptionPane.showMessageDialog(this, "Choisis un URL(Uniform Resource Locator)", "Attention", JOptionPane.WARNING_MESSAGE);
            }else{
                id = (Integer) tb_Url.getValueAt(ligne,2);
                try {
                    leControl.aff_V_Modifier(id);
                    afficherTableau(maCategorie,mois, idMotCle);
                } catch (SQLException ex) {
                    Logger.getLogger(V_Url.class.getName()).log(Level.SEVERE, null, ex);
                } catch (ParseException ex) {
                    Logger.getLogger(V_Url.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }else{
            if(ligne == -1){
                JOptionPane.showMessageDialog(this, "Choisis un URL(Uniform Resource Locator)", "Attention", JOptionPane.WARNING_MESSAGE);
            }else{
                id = (Integer) tb_Url.getValueAt(ligne,2);
                try {
                    M_Url.Sup_Url(bdAutoSearch, id);
                    afficherTableau("Historique",mois, idMotCle);
                } catch (SQLException ex) {
                    Logger.getLogger(V_Url.class.getName()).log(Level.SEVERE, null, ex);
                }

            }
        }
    }//GEN-LAST:event_bt_supActionPerformed

    private void lst_moisActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_lst_moisActionPerformed
        // TODO add your handling code here:
        String valeur = lst_mois.getSelectedItem().toString();
        
        switch (valeur){
            case "Mois":
                    mois = 0;
                    try {
                        afficherTableau("Medecine", mois, idMotCle);
                    } catch (SQLException ex) {
                        Logger.getLogger(V_Url.class.getName()).log(Level.SEVERE, null, ex);
                    }   
                break;
            case "Janvier":
                    mois = 1;
                    try {
                        afficherTableau("Medecine", mois, idMotCle);
                    } catch (SQLException ex) {
                        Logger.getLogger(V_Url.class.getName()).log(Level.SEVERE, null, ex);
                    }
                break;
            case "Fevrier":
                    mois = 2;
                    try {
                        afficherTableau("Medecine", mois, idMotCle);
                    } catch (SQLException ex) {
                        Logger.getLogger(V_Url.class.getName()).log(Level.SEVERE, null, ex);
                    }
                break;
            case "Mars":
                    mois = 3;
                    try {
                        afficherTableau("Medecine", mois, idMotCle);
                    } catch (SQLException ex) {
                        Logger.getLogger(V_Url.class.getName()).log(Level.SEVERE, null, ex);
                    }
                break;
            case "Avril":
                    mois = 4;
                    try {
                        afficherTableau("Medecine", mois, idMotCle);
                    } catch (SQLException ex) {
                        Logger.getLogger(V_Url.class.getName()).log(Level.SEVERE, null, ex);
                    }
                break;
            case "Mai":
                    mois = 5;
                    try {
                        afficherTableau("Medecine", mois, idMotCle);
                    } catch (SQLException ex) {
                        Logger.getLogger(V_Url.class.getName()).log(Level.SEVERE, null, ex);
                    }
                break;
            case "Juin":
                    mois = 6;
                    try {
                        afficherTableau("Medecine", mois, idMotCle);
                    } catch (SQLException ex) {
                        Logger.getLogger(V_Url.class.getName()).log(Level.SEVERE, null, ex);
                    }
                break;
            case "Juillet":
                    mois = 7;
                    try {
                        afficherTableau("Medecine", mois, idMotCle);
                    } catch (SQLException ex) {
                        Logger.getLogger(V_Url.class.getName()).log(Level.SEVERE, null, ex);
                    }
                break;
            case "Aout":
                    mois = 8;
                    try {
                        afficherTableau("Medecine", mois, idMotCle);
                    } catch (SQLException ex) {
                        Logger.getLogger(V_Url.class.getName()).log(Level.SEVERE, null, ex);
                    }
                break;
            case "Septembre":
                    mois = 9;
                    try {
                        afficherTableau("Medecine", mois, idMotCle);
                    } catch (SQLException ex) {
                        Logger.getLogger(V_Url.class.getName()).log(Level.SEVERE, null, ex);
                    }
                break;
            case "Octobre":
                    mois = 10;
                    try {
                        afficherTableau("Medecine", mois, idMotCle);
                    } catch (SQLException ex) {
                        Logger.getLogger(V_Url.class.getName()).log(Level.SEVERE, null, ex);
                    }
                break;
            case "Novembre":
                    mois = 11;
                    try {
                        afficherTableau("Medecine", mois, idMotCle);
                    } catch (SQLException ex) {
                        Logger.getLogger(V_Url.class.getName()).log(Level.SEVERE, null, ex);
                    }
                break;
            case "Decembre":
                    mois = 12;
                    try {
                        afficherTableau("Medecine", mois, idMotCle);
                    } catch (SQLException ex) {
                        Logger.getLogger(V_Url.class.getName()).log(Level.SEVERE, null, ex);
                    }
                break;
        }
        System.out.println(mois);
    }//GEN-LAST:event_lst_moisActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(V_Url.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(V_Url.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(V_Url.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(V_Url.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(() -> {
            new V_Url(null,null).setVisible(true);
        });
    }
    
    public void afficherTableau(String Categorie, int mois, int idMotCle) throws SQLException{
        //affectation des varaibles
        lesCategories = M_Categorie.records(bdAutoSearch);
        lst_Categories.setBorder(BorderFactory.createTitledBorder("Categorie :"));
        int k=0;
        Component cel;
        int noLigne=0;
        dm_tb_url = (DefaultTableModel) tb_Url.getModel();
        lesUrl = M_Url.records(bdAutoSearch, Categorie, mois, idMotCle);
        
        if(lesUrl.size()==0){
            dm_tb_url.setRowCount(1);
            dm_tb_url.setValueAt("Aucune Url", noLigne, 0);
            dm_tb_url.setValueAt(" ", noLigne, 3);
            bt_Aller.setVisible(false);
            bt_sup.setVisible(false);
        }else{
            bt_Aller.setVisible(true);
            //pour chaque url présent des la colection
            for (int z = 0; z < lesUrl.size(); z++) {
                //selectionner l'url à l'index z
                M_Url lUrl = lesUrl.get(z);

                //Déclare le nombre de ligne du tableau
                dm_tb_url.setRowCount(lesUrl.size());
                Date dateStr;
                dateStr = lUrl.getDate();
                SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy"); 
                String d = sdf.format(dateStr);

                //rempli le tableau avec les informations de l'Url
                dm_tb_url.setValueAt(lUrl.getTitre(), noLigne, 0);
                dm_tb_url.setValueAt(lUrl.getUrl(), noLigne, 1);
                dm_tb_url.setValueAt(lUrl.getId(), noLigne, 2);
                dm_tb_url.setValueAt(d+" "+lUrl.getHeure().toString().substring(0, 5), noLigne, 3);

                //incrémentation de noLigne
                noLigne++;
            }
        }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bt_Aller;
    private javax.swing.JButton bt_Retour;
    private javax.swing.JButton bt_sup;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JPanel lst_Categories;
    private javax.swing.JComboBox<String> lst_mois;
    private javax.swing.JTable tb_Url;
    // End of variables declaration//GEN-END:variables
}
